.sect .text; .sect .rom; .sect .data; .sect .bss
.extern _hardclock
.sect .text
_hardclock:
	push	bp
	mov	bp,sp
push si
mov si,(_calltodo)
jmp I1_1
I1_6:
cmp 2(si),0
je I1_3
mov dx,2(si)
sub dx,1
mov 2(si),dx
jmp I1_2
I1_3:
mov si,(si)
I1_1:
or si,si
jne I1_6
I1_2:
mov si,(_curproc)
cmpb 6(si),4
jne I1_4
movb al,9(si)
cbw
cmp ax,255
je I1_4
cbw
inc ax
movb 9(si),al
I1_4:
inc (_lbolt)
cmp (_lbolt),100
jl I1_5
sub (_lbolt),100
add (_time),1
adc (_time+2),0
movb (_runrun),1
movb (_recalc),1
I1_5:
jmp .sret
.extern _softclock
_softclock:
	push	bp
	mov	bp,sp
	sub	sp,10
push si
push di
I2_9:
call _splclock
mov si,(_calltodo)
or si,si
je I2_2
cmp 2(si),0
jne I2_2
mov dx,(si)
mov (_calltodo),dx
mov dx,(_callfree)
mov (si),dx
mov (_callfree),si
mov di,6(si)
mov si,4(si)
call _spl0
push si
call di
pop bx
jmp I2_9
I2_2:
call _spl0
cmpb (_recalc),0
je I2_3
movb (_recalc),0
mov ax,_lbolt
push ax
call _wakeup
pop bx
mov si,_proc
jmp I2_4
I2_10:
movb al,6(si)
cbw
cmp ax,2
jle I2_5
movb dl,9(si)
xorb dh,dh
mov cx,3
mov bx,dx
sal bx,cl
add dx,bx
mov cx,10
mov ax,dx
cwd
idiv cx
mov bx,ax
movb al,8(si)
cbw
add ax,bx
sub ax,20
mov di,ax
or di,di
jns I2_6
xor di,di
I2_6:
cmp di,255
jle I2_7
mov di,255
I2_7:
mov dx,di
movb 9(si),dl
movb al,7(si)
cbw
cmp ax,50
jl I2_8
push si
call _setpri
pop bx
I2_8:
cmp 22(si),0
je I2_5
dec 22(si)
jne I2_5
mov ax,14
push ax
push si
call _psignal
pop bx
pop bx
I2_5:
add si,512
I2_4:
cmp si,_proc+15360
jb I2_10
I2_3:
jmp .dsret
.extern _timeout
_timeout:
	push	bp
	mov	bp,sp
	sub	sp,8
push si
push di
mov di,_calltodo
call _splclock
mov -8(bp),ax
mov dx,(_callfree)
mov -6(bp),dx
mov bx,-6(bp)
mov dx,(bx)
mov (_callfree),dx
cmp -6(bp),0
jne I3_1
mov ax,__II0
push ax
call _panic
pop bx
jmp I3_1
I3_4:
mov dx,8(bp)
cmp 2(si),dx
jbe I3_3
mov dx,2(si)
sub dx,8(bp)
mov 2(si),dx
jmp I3_2
I3_3:
mov dx,8(bp)
sub dx,2(si)
mov 8(bp),dx
mov di,si
I3_1:
mov si,(di)
or si,si
jne I3_4
I3_2:
mov bx,-6(bp)
mov (bx),si
! kill bx
mov bx,-6(bp)
mov dx,8(bp)
mov 2(bx),dx
mov bx,-6(bp)
mov dx,6(bp)
mov 4(bx),dx
mov bx,-6(bp)
mov dx,4(bp)
mov 6(bx),dx
mov dx,-6(bp)
mov (di),dx
push -8(bp)
call _splx
pop bx
jmp .dsret
.extern _callout_init
_callout_init:
	push	bp
	mov	bp,sp
push si
mov si,_callspace
I4_1:
mov dx,(_callfree)
mov (si),dx
mov (_callfree),si
add si,8
cmp si,_callspace+320
jne I4_1
jmp .sret
.extern _recalc
.sect .bss
.comm _recalc,2
.extern _callspace
.comm _callspace,320
.extern _callfree
.comm _callfree,2
.extern _calltodo
.comm _calltodo,2
.extern _time
.comm _time,4
.sect .data
__II0:
.data2	30031
.data2	8308
.data2	26223
.data2	25376
.data2	27745
.data2	28524
.data2	29813
.data2	115
.sect .text
