.sect .text; .sect .rom; .sect .data; .sect .bss
.extern _sys_read
.sect .text
_sys_read:
	push	bp
	mov	bp,sp
push 8(bp)
push 6(bp)
push 4(bp)
mov ax,1
push ax
call _rdwr
add sp,8
jmp .cret
.extern _sys_write
_sys_write:
	push	bp
	mov	bp,sp
push 8(bp)
push 6(bp)
push 4(bp)
mov ax,2
push ax
call _rdwr
add sp,8
jmp .cret
.extern _rdwr
_rdwr:
	push	bp
	mov	bp,sp
push si
push di
cmp 10(bp),0
jns I3_1
movb (_errno),22
jmp I3_2
I3_1:
push 6(bp)
call _getf
pop bx
mov si,ax
or si,si
je I3_2
movb al,(si)
cbw
test 4(bp),ax
jne I3_3
movb (_errno),9
jmp I3_2
I3_3:
mov bx,(_curproc)
mov dx,10(bp)
mov 72(bx),dx
mov bx,(_curproc)
mov dx,8(bp)
mov 74(bx),dx
mov bx,(_curproc)
! kill bx
movb 76(bx),1
testb (si),64
je I3_4
cmp 4(bp),1
jne I3_5
push si
call _readp
I3_14:
pop bx
jmp I3_6
I3_5:
push si
call _writep
jmp I3_14
I3_4:
mov di,2(si)
testb 15(di),32
jne I3_7
push di
call _plock
pop bx
I3_7:
cmp 4(bp),2
jne I3_8
testb (si),4
je I3_8
mov dx,10(di)
mov cx,12(di)
mov 4(si),dx
mov 6(si),cx
I3_8:
mov bx,(_curproc)
mov dx,4(si)
mov cx,6(si)
mov 68(bx),dx
mov 70(bx),cx
cmp 4(bp),1
jne I3_9
movb al,(si)
cbw
push ax
push di
call _readi
jmp I3_13
I3_9:
movb al,(si)
cbw
push ax
push di
call _writei
I3_13:
pop bx
pop bx
testb 15(di),32
jne I3_11
push di
call _prele
pop bx
I3_11:
mov bx,(_curproc)
mov dx,10(bp)
sub dx,72(bx)
xor cx,cx
add dx,4(si)
adc cx,6(si)
mov 4(si),dx
mov 6(si),cx
I3_6:
mov bx,(_curproc)
mov dx,10(bp)
sub dx,72(bx)
mov ax,dx
jmp I3_12
I3_2:
mov ax,bp
I3_12:
jmp .dsret
.extern _sys_open
_sys_open:
	push	bp
	mov	bp,sp
	sub	sp,6
push si
push di
lea ax,-6(bp)
push ax
call _falloc
pop bx
mov di,ax
or ax,ax
je I4_10
mov si,4(bp)
test 6(bp),256
je I4_3
mov ax,1
push ax
push si
call _namei
pop bx
pop bx
mov si,ax
or si,si
jne I4_4
cmpb (_errno),0
jne I4_5
mov dx,7
and dx,8(bp)
or dx,128
push dx
call _maknode
pop bx
mov si,ax
and 6(bp),-513
jmp I4_6
I4_4:
test 6(bp),1024
je I4_7
movb (_errno),17
jmp I4_5
I4_7:
and 6(bp),-257
jmp I4_6
I4_3:
xor ax,ax
push ax
push si
call _namei
pop bx
pop bx
mov si,ax
I4_6:
or si,si
je I4_5
test 6(bp),256
jne I4_8
mov dx,3
and dx,6(bp)
push dx
push si
call _access
pop bx
pop bx
or ax,ax
je I4_5
testb 6(bp),2
je I4_8
movb dl,15(si)
xorb dh,dh
and dx,224
cmp dx,192
jne I4_8
movb (_errno),21
jmp I4_5
I4_8:
test 6(bp),512
je I4_9
push si
call _itrunc
pop bx
I4_9:
push si
call _prele
mov dx,63
and dx,6(bp)
movb (di),dl
mov 2(di),si
push di
call _openf
pop bx
pop bx
mov si,2(di)
cmpb (_errno),0
jne I4_5
mov ax,-6(bp)
jmp I4_2
I4_5:
mov bx,(_curproc)
! kill bx
add bx,98
mov dx,-6(bp)
sal dx,1
add bx,dx
mov (bx),0
movb 1(di),0
mov 2(di),0
or si,si
je I4_10
push si
call _iput
pop bx
I4_10:
mov ax,-1
I4_2:
jmp .dsret
.extern _sys_close
_sys_close:
	push	bp
	mov	bp,sp
push si
push 4(bp)
call _getf
pop bx
mov si,ax
or si,si
jne I5_1
mov ax,-1
push ax
jmp I5_2
I5_1:
mov bx,(_curproc)
! kill bx
add bx,98
mov dx,4(bp)
sal dx,1
add bx,dx
mov (bx),0
push si
call _closef
I5_2:
pop ax
jmp .sret
.extern _sys_lseek
_sys_lseek:
	push	bp
	mov	bp,sp
push si
.sect .rom
__II0:
.data2	I6_1
.data2	1
.data2	1
.data2	I6_2
.data2	I6_3
.sect .text
push 4(bp)
call _getf
pop bx
mov si,ax
or si,si
jne I6_4
I6_7:
mov ax,-1
push ax
mov ax,65535
push ax
jmp I6_5
I6_4:
testb (si),64
je I6_6
movb (_errno),29
jmp I6_7
I6_2:
mov dx,4(si)
mov cx,6(si)
add 6(bp),dx
adc 8(bp),cx
jmp I6_1
I6_3:
mov bx,2(si)
mov dx,10(bx)
mov cx,12(bx)
add 6(bp),dx
adc 8(bp),cx
jmp I6_1
I6_6:
mov ax,10(bp)
mov bx,__II0
jmp .csa2
I6_1:
mov dx,6(bp)
mov cx,8(bp)
mov 4(si),dx
mov 6(si),cx
push 8(bp)
push 6(bp)
I6_5:
pop ax
pop dx
jmp .sret
.extern _sys_mknod
_sys_mknod:
	push	bp
	mov	bp,sp
push si
mov ax,1
push ax
push 4(bp)
call _namei
pop bx
pop bx
mov si,ax
or si,si
je I7_1
movb (_errno),17
jmp I7_2
I7_1:
cmpb (_errno),0
jne I7_3
push 6(bp)
call _maknode
pop bx
mov si,ax
or si,si
je I7_3
testb 6(bp),32
je I7_2
mov ax,8(bp)
cwd
mov 16(si),ax
mov 18(si),dx
I7_2:
push si
call _iput
pop bx
I7_3:
jmp .sret
.extern _sys_link
_sys_link:
	push	bp
	mov	bp,sp
push si
push di
xor ax,ax
push ax
push 4(bp)
call _namei
pop bx
pop bx
mov si,ax
or si,si
je I8_1
movb al,14(si)
cbw
cmp ax,255
jne I8_2
movb (_errno),31
jmp I8_3
I8_2:
push si
call _prele
mov ax,1
push ax
push 6(bp)
call _namei
add sp,6
mov di,ax
or di,di
je I8_4
movb (_errno),17
push di
call _iput
pop bx
jmp I8_3
I8_4:
cmpb (_errno),0
jne I8_3
mov bx,(_curproc)
mov bx,138(bx)
mov dx,4(si)
cmp 4(bx),dx
je I8_5
mov bx,(_curproc)
push 138(bx)
call _iput
pop bx
movb (_errno),18
jmp I8_3
I8_5:
push 2(si)
call _wdir
pop bx
cmpb (_errno),0
jne I8_3
movb al,14(si)
cbw
inc ax
movb 14(si),al
movb al,(si)
cbw
or ax,32
movb (si),al
I8_3:
push si
call _iput
pop bx
I8_1:
jmp .dsret
.extern _sys_unlink
_sys_unlink:
	push	bp
	mov	bp,sp
push si
push di
mov ax,2
push ax
push 4(bp)
call _namei
pop bx
pop bx
mov di,ax
or di,di
je I9_1
mov bx,(_curproc)
mov dx,140(bx)
cmp 2(di),dx
jne I9_2
mov si,di
movb al,1(si)
cbw
inc ax
movb 1(si),al
jmp I9_3
I9_2:
mov bx,(_curproc)
push 140(bx)
push 4(di)
call _iget
pop bx
pop bx
mov si,ax
or si,si
je I9_4
I9_3:
mov dx,4(di)
cmp 4(si),dx
je I9_5
movb (_errno),16
jmp I9_6
I9_5:
mov bx,(_curproc)
mov 140(bx),0
mov bx,(_curproc)
mov dx,68(bx)
mov cx,70(bx)
sub dx,16
sbb cx,0
mov 68(bx),dx
mov 70(bx),cx
mov bx,(_curproc)
mov 72(bx),16
mov bx,(_curproc)
! kill bx
add bx,140
push bx
mov bx,(_curproc)
pop dx
mov 74(bx),dx
mov bx,(_curproc)
! kill bx
movb 76(bx),0
xor ax,ax
push ax
push di
call _writei
pop bx
pop bx
cmpb 14(si),0
je I9_6
movb al,14(si)
cbw
dec ax
movb 14(si),al
movb al,(si)
cbw
or ax,32
movb (si),al
I9_6:
push si
call _iput
pop bx
I9_4:
push di
call _iput
pop bx
I9_1:
jmp .dsret
.extern _sys_mkdir
_sys_mkdir:
	push	bp
	mov	bp,sp
	sub	sp,34
push si
.sect .data
__II1:
.data2	11822
.data2	0
.data2	0
.data2	0
.data2	0
.data2	0
.data2	0
.data2	0
.sect .text
mov ax,1
push ax
push 4(bp)
call _namei
pop bx
pop bx
mov si,ax
or si,si
je Ia_1
movb (_errno),17
jmp Ia_2
Ia_1:
cmpb (_errno),0
jne Ia_3
mov bx,(_curproc)
mov si,138(bx)
movb al,14(si)
cbw
cmp ax,255
jne Ia_4
movb (_errno),31
jmp Ia_2
Ia_4:
movb al,14(si)
cbw
inc ax
movb 14(si),al
mov dx,2(si)
mov -18(bp),dx
mov dx,7
and dx,6(bp)
or dx,192
push dx
call _maknode
pop bx
mov si,ax
or si,si
je Ia_3
movb al,14(si)
cbw
inc ax
movb 14(si),al
mov dx,2(si)
mov -34(bp),dx
mov ax,14
push ax
lea ax,-32(bp)
push ax
mov ax,__II1+1
push ax
call _bcopy
mov ax,14
push ax
lea ax,-16(bp)
push ax
mov ax,__II1
push ax
call _bcopy
xor ax,ax
mov bx,(_curproc)
mov 68(bx),ax
mov 70(bx),ax
mov bx,(_curproc)
mov 72(bx),32
lea ax,-34(bp)
push ax
mov bx,(_curproc)
pop dx
mov 74(bx),dx
mov bx,(_curproc)
! kill bx
movb 76(bx),0
xor ax,ax
push ax
push si
call _writei
add sp,16
Ia_2:
push si
call _iput
pop bx
Ia_3:
jmp .sret
.extern _sys_chdir
_sys_chdir:
	push	bp
	mov	bp,sp
push si
xor ax,ax
push ax
push 4(bp)
call _namei
pop bx
pop bx
mov si,ax
or si,si
je Ib_1
movb dl,15(si)
xorb dh,dh
and dx,224
cmp dx,192
je Ib_2
movb (_errno),20
jmp Ib_3
Ib_2:
mov ax,1
push ax
push si
call _access
pop bx
pop bx
or ax,ax
je Ib_3
push si
call _prele
mov bx,(_curproc)
push 16(bx)
call _plock
mov bx,(_curproc)
push 16(bx)
call _iput
add sp,6
mov bx,(_curproc)
mov 16(bx),si
jmp Ib_1
Ib_3:
push si
call _iput
pop bx
Ib_1:
jmp .sret
.extern _sys_chmod
_sys_chmod:
	push	bp
	mov	bp,sp
push si
xor ax,ax
push ax
push 4(bp)
call _namei
pop bx
pop bx
mov si,ax
or ax,ax
je Ic_1
movb dl,15(si)
xorb dh,dh
and dx,65528
movb 15(si),dl
mov dx,7
and dx,6(bp)
movb cl,15(si)
xorb ch,ch
or cx,dx
movb 15(si),cl
movb al,(si)
cbw
or ax,32
movb (si),al
push si
call _iput
pop bx
Ic_1:
jmp .sret
.extern _sys_fchmod
_sys_fchmod:
	push	bp
	mov	bp,sp
push si
push 4(bp)
call _getf
pop bx
mov si,ax
or ax,ax
je Id_1
mov si,2(si)
push si
call _plock
pop bx
movb dl,15(si)
xorb dh,dh
and dx,65528
movb 15(si),dl
mov dx,7
and dx,6(bp)
movb cl,15(si)
xorb ch,ch
or cx,dx
movb 15(si),cl
movb al,(si)
cbw
or ax,32
movb (si),al
push si
call _prele
pop bx
Id_1:
jmp .sret
.extern _sys_ioctl
_sys_ioctl:
	push	bp
	mov	bp,sp
	sub	sp,6
push si
push di
.sect .rom
__II2:
.data2	Ie_1
.data2	26113
.data2	1
.data2	Ie_2
.data2	Ie_3
.sect .text
mov di,4(bp)
push di
call _getf
pop bx
mov si,ax
or ax,ax
jne Ie_4
jmp Ie_5
Ie_2:
mov bx,(_curproc)
! kill bx
add bx,di
add bx,78
mov si,bx
movb al,(bx)
cbw
or ax,1
movb (si),al
jmp Ie_5
Ie_3:
mov bx,(_curproc)
! kill bx
add bx,di
add bx,78
mov si,bx
movb al,(bx)
cbw
and ax,-2
movb (si),al
jmp Ie_5
Ie_4:
mov ax,6(bp)
mov bx,__II2
jmp .csa2
Ie_1:
mov di,2(si)
mov dx,16(di)
mov -6(bp),dx
movb dl,15(di)
xorb dh,dh
and dx,224
cmp dx,32
je Ie_6
movb (_errno),25
jmp Ie_5
Ie_6:
movb al,(si)
cbw
mov cx,8
mov dx,-6(bp)
shr dx,cl
xorb dh,dh
mov cx,4
sal dx,cl
add dx,_cdevsw
mov bx,dx
push ax
push 8(bp)
push 6(bp)
push -6(bp)
call 8(bx)
add sp,8
jmp Ie_7
Ie_5:
mov ax,bp
Ie_7:
jmp .dsret
