.sect .text; .sect .rom; .sect .data; .sect .bss
.extern _sys_sync
.sect .text
_sys_sync:
	push	bp
	mov	bp,sp
call _update
jmp .cret
.extern _sys_getpid
_sys_getpid:
	push	bp
	mov	bp,sp
mov bx,(_curproc)
mov ax,10(bx)
jmp .cret
.extern _sys_getppid
_sys_getppid:
	push	bp
	mov	bp,sp
mov bx,(_curproc)
mov bx,2(bx)
mov ax,10(bx)
jmp .cret
.extern _sys_nice
_sys_nice:
	push	bp
	mov	bp,sp
push si
mov bx,(_curproc)
! kill bx
movb al,8(bx)
cbw
add ax,4(bp)
mov si,ax
cmp si,39
jle I4_1
mov si,39
I4_1:
or si,si
jns I4_2
xor si,si
I4_2:
mov bx,(_curproc)
! kill bx
mov dx,si
movb 8(bx),dl
jmp .sret
.extern _sys_pause
_sys_pause:
	push	bp
	mov	bp,sp
mov bx,(_curproc)
! kill bx
mov ax,40
push ax
add bx,68
push bx
call _sleep
pop bx
pop bx
jmp .cret
.extern _sys_settimeofday
_sys_settimeofday:
	push	bp
	mov	bp,sp
	sub	sp,10
mov ax,8
push ax
lea ax,-8(bp)
push ax
push 4(bp)
call _copyin
add sp,6
or ax,ax
je I6_1
movb (_errno),14
jmp I6_2
I6_1:
mov ax,100
xor dx,dx
push -2(bp)
push -4(bp)
call .mli4
push dx
push ax
mov ax,15
push ax
mov ax,16960
push ax
call .dvi4
mov -10(bp),ax
call _splclock
mov dx,-8(bp)
mov cx,-6(bp)
mov (_time),dx
mov (_time+2),cx
mov dx,-10(bp)
mov (_lbolt),dx
call _spl0
I6_2:
jmp .cret
.extern _sys_gettimeofday
_sys_gettimeofday:
	push	bp
	mov	bp,sp
	sub	sp,8
push si
push di
mov di,100
call _splclock
mov dx,(_time)
mov cx,(_time+2)
mov -8(bp),dx
mov -6(bp),cx
mov si,(_lbolt)
call _spl0
jmp I7_1
I7_4:
mov dx,si
sub dx,di
mov si,dx
add -8(bp),1
adc -6(bp),0
I7_1:
cmp si,di
jae I7_4
mov ax,10000
xor dx,dx
xor bx,bx
push bx
push si
call .mli4
mov -4(bp),ax
mov -2(bp),dx
mov ax,8
push ax
push 4(bp)
lea ax,-8(bp)
push ax
call _copyout
add sp,6
or ax,ax
je I7_3
movb (_errno),14
I7_3:
jmp .dsret
.extern _sys_alarm
_sys_alarm:
	push	bp
	mov	bp,sp
	push	ax
	push	ax
push si
mov si,(_curproc)
mov dx,22(si)
mov -4(bp),dx
mov cx,2
mov dx,4(bp)
sal dx,cl
mov cx,3
mov bx,dx
sal bx,cl
sub dx,bx
mov cx,2
sal bx,cl
add dx,bx
mov 22(si),dx
mov ax,-4(bp)
jmp .sret
.extern _sys_signal
_sys_signal:
	push	bp
	mov	bp,sp
	push	ax
	push	ax
push si
push di
mov si,(_curproc)
! kill cc
cmp 4(bp),0
jle I9_1
cmp 4(bp),16
jge I9_1
cmp 4(bp),9
jne I9_2
I9_1:
movb (_errno),22
jmp I9_3
I9_2:
mov dx,4(bp)
lea bx,36(si)
sal dx,1
add bx,dx
mov di,bx
mov dx,(di)
mov -4(bp),dx
mov dx,6(bp)
mov (di),dx
mov dx,4(bp)
dec dx
mov cx,dx
mov dx,1
sal dx,cl
not dx
and 14(si),dx
mov ax,-4(bp)
jmp I9_4
I9_3:
mov ax,bp
I9_4:
jmp .dsret
.extern _sys_kill
_sys_kill:
	push	bp
	mov	bp,sp
	push	ax
	push	ax
push si
mov -4(bp),3
mov si,_proc
jmp Ia_1
Ia_6:
cmpb 6(si),0
je Ia_3
cmp 4(bp),-1
jne Ia_4
cmp si,_proc
je Ia_3
mov bx,(_curproc)
mov dx,12(bx)
cmp 12(si),dx
jne Ia_3
mov dx,4(bp)
cmp 10(si),dx
jne Ia_3
Ia_4:
cmp 6(bp),0
je Ia_5
push 6(bp)
push si
call _psignal
pop bx
pop bx
Ia_5:
mov -4(bp),0
Ia_3:
add si,512
Ia_1:
cmp si,_proc+15360
jb Ia_6
mov dx,-4(bp)
movb (_errno),dl
jmp .sret
