
/*
 * The callout structure is for
 * a routine arranging
 * to be called by the clock interrupt
 * (clock.c) with a specified argument,
 * in a specified amount of time.
 * Used, for example, to time tab
 * delays on typewriters.
 */

struct callout {
	struct callout *c_next;
	unsigned c_time;	/* incremental time */
	unsigned c_arg;		/* argument to routine */
	void (*c_func)();	/* routine */
};

